=encoding utf8

=head1 NAME

Mail::Message::TransferEnc::Base64 - encode/decode base64 message bodies

=head1 INHERITANCE

 Mail::Message::TransferEnc::Base64
   is a Mail::Message::TransferEnc
   is a Mail::Reporter

=head1 SYNOPSIS

  my Mail::Message $msg = ...;
  my $decoded = $msg->decoded;
  my $encoded = $msg->encode(transfer => 'base64');

=head1 DESCRIPTION

Encode or decode message bodies with base64.  The e-mail protocol and
user agents can not handle binary data.  Therefore, binary data -but
even sometimes non-binary data- is encoded into ASCII, this is
transportable.

Base64 re-groups the bits of bytes, and maps them on characters. The
data contains bytes of 8 bits (an I<octet>).  These are repacked into
groups of 6 bits, pointing in an array of characters containing
C<[A-Za-z0-9+/]>.  This way, three data bytes become 4 base64 bytes.
The encoded data will be trailed by C<'='> characters to align on
four bytes.

Extends L<"DESCRIPTION" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Attributes">.

=head2 The Encoder

Extends L<"The Encoder" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"The Encoder">.

=over 4

=item $class-E<gt>B<addTransferEncoder>($type, $class)

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=item $obj-E<gt>B<create>($type, %options)

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::TransferEnc/"The Encoder">

=back

=head2 Encoding

Extends L<"Encoding" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Encoding">.

=over 4

=item $obj-E<gt>B<check>($body, %options)

Inherited, see L<Mail::Message::TransferEnc/"Encoding">

=item $obj-E<gt>B<decode>($body, %options)

Inherited, see L<Mail::Message::TransferEnc/"Encoding">

 -Option     --Defined in                --Default
  result_type  Mail::Message::TransferEnc  <type of source body>

=over 2

=item result_type => CLASS

=back

=item $obj-E<gt>B<encode>($body, %options)

Inherited, see L<Mail::Message::TransferEnc/"Encoding">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::TransferEnc|Mail::Message::TransferEnc/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Warning: Base64 line length not padded on 4.

While decoding base64 the data in a message body, a string was found which
was not padded into a multiple of four bytes.  This is illegal, and therefore
this data is ignored.
Cast by C<decode()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: decoder for transfer encoding $type does not work: $@

Compiling the required transfer encoding resulted in errors, which means
that the decoder can not be used.
Cast by C<create()>

=item Error: no decoder for transfer encoding $type.

A decoder for the specified type of transfer encoding is not implemented.
Cast by C<create()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

